datablock AudioProfile(burgerEat1Sound)
{
	filename    = "./eatCrunch1.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(burgerEat2Sound)
{
	filename    = "./eatCrunch2.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock DebrisData(burgerEat1Debris)
{
	shapeFile = "./bit1.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock DebrisData(burgerEat2Debris)
{
	shapeFile = "./bit2.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock DebrisData(burgerEat3Debris)
{
	shapeFile = "./bit3.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock DebrisData(burgerEat4Debris)
{
	shapeFile = "./bit4.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ParticleData(burgerEatParticle)
{
   dragCoefficient = 8;
   gravityCoefficient = 0.3;
   inheritedVelFactor = 3;
   constantAcceleration = 0;
   lifetimeMS         = 400;
   lifetimeVarianceMS = 200;
   textureName = "base/data/particles/cloud";
   spinSpeed     = 0;
   spinRandomMin = -20;
   spinRandomMax = 20;
   colors[0] = "0.7 0.5 0.3 0.5";
   colors[1] = "0.7 0.44 0.1 0.3";
   colors[2] = "0.7 0.37 0.0 0";
   sizes[0] = 0.29;
   sizes[1] = 0.32;
   sizes[2] = 0.47;
   times[1] = 0.6;
   times[2] = 1;
   useInvAlpha = true;
};
datablock ParticleEmitterData(burgerEatEmitter)
{
	ejectionPeriodMS = 7;
	periodVarianceMS = 0;
	velocityVariance = 2;
	ejectionVelocity = 1;
	ejectionOffset   = 0.1;
	thetaMin         = 0;
	thetaMax         = 180;
	phiReferenceVel = 0;
	phiVariance     = 360;
	overrideAdvance = false;
	lifetimeMS = 3500;
	particles = burgerEatParticle;
};

datablock ExplosionData(burgerEatSub1Explosion)
{
	debris 					= burgerEat2Debris;
	debrisNum 				= 4;
	debrisNumVariance 		= 2;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 50;
	debrisVelocity 			= 3;
	debrisVelocityVariance 	= 1;
};
datablock ExplosionData(burgerEatSub2Explosion)
{
	debris 					= burgerEat3Debris;
	debrisNum 				= 8;
	debrisNumVariance 		= 2;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 50;
	debrisVelocity 			= 3;
	debrisVelocityVariance 	= 1;
};
datablock ExplosionData(burgerEatSub3Explosion)
{
	debris 					= burgerEat4Debris;
	debrisNum 				= 5;
	debrisNumVariance 		= 2;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 50;
	debrisVelocity 			= 3;
	debrisVelocityVariance 	= 1;
};
datablock ExplosionData(burgerEatExplosion)
{
	debris 					= burgerEat1Debris;
	debrisNum 				= 4;
	debrisNumVariance 		= 2;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 50;
	debrisVelocity 			= 3;
	debrisVelocityVariance 	= 1;
	emitter[0] = burgerEatEmitter;
	subExplosion[0] = burgerEatSub1Explosion;
	subExplosion[1] = burgerEatSub2Explosion;
	subExplosion[2] = burgerEatSub3Explosion;
	
	lifeTimeMs = 100;
};
datablock ProjectileData(burgerEatProjectile)
{
	explosion = burgerEatExplosion;
	lifeTimeMs = 10;
	explodeOnDeath = 1;
};
datablock ItemData(burgerItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "food";

	shapeFile = "./burger.dts";
	rotate = true;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	image = burgerImage;
	
	uiName = "Burger";
	iconName = "./icon_burger";
	doColorShift = true;
	colorShiftColor = "0.8 0.47 0.1 1";
	canDrop = true;
};

datablock shapeBaseImageData(burgerImage)
{
	className = "WeaponImage";
	shapeFile = "./burger.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0 0.12 0.05";
	rotation = eulerToMatrix("90 -100 0");
	
	doColorShift = true;
	colorShiftColor = burgerItem.colorShiftColor;
	
	item = "";
	ammo = "";
	
	armReady = true;
	
	stateName[0] 					= "Ready";
	stateTimeoutValue[0]			= 0.08;
	stateTransitionOnTimeout[0]		= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnTriggerDown[1]	= "Eat";
	
	stateName[2]					= "Eat";
	stateScript[2]					= "onEat";
};

function burgerImage::onEat(%db,%pl,%slot)
{
	%pl.playThread(3,activate);
	%pl.playThread(0,rotCCW);
	%pl.disableCmdSwap = 1;
	%db.schedule(60,eatEffect,%pl,%slot);
	%pl.tool[%pl.currTool] = 0;
	%pl.weaponCount--;
	if(isObject(%cl = %pl.client))
		messageClient(%cl,'MsgItemPickup','',%pl.currTool,"",1);
}
function burgerImage::finishEffect(%db,%pl,%slot)
{
	%pl.disableCmdSwap = 0;
	if(%pl.switchToTool !$= "")
	{
		if(isObject(%cl = %pl.client))
			serverCmdUseTool(%cl,%pl.switchToTool-1);
		%pl.switchToTool = "";
	}
}
function burgerImage::eatEffect(%db,%pl,%slot)
{
	%p = new projectile()
	{
		datablock = burgerEatProjectile;
		initialPosition = (%slotPos = %pl.getSlotTransform(%slot));
		initialVelocity = %pl.getForwardVector();
	};
	%p.explode();
	%pl.unMountImage(%slot);
	%cnt = clientGroup.getCount();
	%rnd = getRandom(1,2);
	for(%i=0;%i<%cnt;%i++)
	{
		%cl = clientGroup.getObject(%i);
		%cl.play3D(burgerEat @ %rnd @ Sound,%slotPos);
	}
	%rnd = getRandom(1,60);
	%amt = 65; 
	if(isObject(%cl = %pl.client))
	{
		if(%rnd == 60)
		{
			%msg = "This is the best burger I've ever eaten!!!";
			messageAll('',"\c3" @ %pl.client.getPlayerName() @ " \c6just ate a legendary burger");
			%pl.emote(winStarProjectile,2);
			serverPlay3D(rewardSound,%pl.getPosition());
			%amt = 100;
		}
		else if(%rnd > 40)
			%msg = "A delicious burger!!";
		else if(%amt > 25)
			%msg = "This is a great burger!";
		else if(%amt > 0)
			%msg = "A very good burger";
		%pl.setWhiteOut(%amt/200);
		centerPrint(%cl,"<br><br>\c6" @ %msg,3);
	}
	%pl.addHealth(%amt);
	%pl.schedule(600,playThread,1,root);
	%pl.schedule(550,playThread,2,shiftTo);
	%db.schedule(850,finishEffect,%pl,%slot);
}

package swol_burger
{
	function serverCmdUseTool(%cl,%slot)
	{
		if(!isObject(%pl = %cl.player))
			return parent::serverCmdUseTool(%cl,%slot);
		if(%pl.disableCmdSwap)
			return %pl.switchToTool = %slot+1;
		return parent::serverCmdUseTool(%cl,%slot);
	}
	function serverCmdUnUseTool(%cl)
	{
		if(!isObject(%pl = %cl.player))
			return parent::serverCmdUnUseTool(%cl);
		if(%pl.disableCmdSwap)
			return %pl.switchToTool = "";
		return parent::serverCmdUnUseTool(%cl);
	}
};
activatePackage(swol_burger);